# Copyright (C) 2018 Svetlana Tkachenko svetlana@members.fsf.org
#
#    This file is part of WeABit, Welcome-a-bit for Wikinews.
#
#    WeABit is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    WeABit is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with WeABit.  If not, see <https://www.gnu.org/licenses/>.

# 1. read in a list of rss feeds and usernames
# 2. 

use strict;
use warnings;

use MediaWiki::API;
use LWP::Simple;

use Data::Dumper;
use String::Util qw(trim);


use wabget;

my $mw = MediaWiki::API->new();
my $wikiURL = 'https://en.wikinews.org'; # /w/api.php';
$mw->{config}->{api_url} = "$wikiURL/w/api.php";

# Check for new messages for $hr = {
#		        'cat' => $cat,
#		        'username' => $username,
#		        'title' => $title    
#	        };

while(1){
	# get category members of 'Gryllida/WAB'
	my $members_ref = $mw->api ( {
		action      => 'query',
		list => 'categorymembers',
		cmtitle => 'Category:Gryllida/WAB' 
	});
	my $members = $members_ref->{query}->{categorymembers};
	my $n = scalar(@{$members});

	# For each WAB tracking page, extract the username and categories therein.
	for (my $i=0; $i < $n; $i++) {
		my $title = $members->[$i]->{title};
		my @partsOfTitle = split /\//, $title;
		$partsOfTitle[0] =~ s/User\://;
		my $username =$partsOfTitle[0];
		my $typeOfArticles =$partsOfTitle[2]; # dev or pub
		my $deliveryType =$partsOfTitle[3]; # email or wiki
		# Get the user's time stamp
		my $talkPageTitle = "User talk:$username/wab/$typeOfArticles/$deliveryType";
		my $url2 = "$wikiURL/wiki/$talkPageTitle?action=raw";
		my $content2 = get($url2);
		my @lines2 =  split /^/, $content2;
		my $userTs = $lines2[0];
		print $userTs;
		# Get list of categories of the user
		my $url = "$wikiURL/wiki/$title?action=raw";
		my $content = get($url);
		my @lines =  split /^/, $content;
		
		for my $line (@lines){
			chomp($line);
			if ($line =~ s/\*(.*)/$1/){
				my $cat = trim($line);
				
				# For this username and category, check for new messages.
				wabget->_my_process_cat({
					'cat' => $cat,
					'username' => $username,
					'title' => $title,
					'userTs' => $userTs,
					'deliveryType' => $deliveryType,
					'articleType' => $typeOfArticles,
					'wikiURL' => $wikiURL,
					'talkPageTitle' => $talkPageTitle
				});
			}
		}
	}
	sleep(10);
}
